using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace UNSCI
{
    public class Infantry
    {
        private const string V = "ODST-bz";

        public static void Main()
        {
            //ODST
            ModAPI.Register(
			    new Modification()
			    {
			        OriginalItem = ModAPI.FindSpawnable("Human"), 
			        NameOverride = "ODST -buzz", 
			        DescriptionOverride = "Orbital Drop Shock Troopers, elite soldiers that fall from the sky!",
			        CategoryOverride = ModAPI.FindCategory("Entities"), 
			        ThumbnailOverride = ModAPI.LoadSprite("ODSTicon.png"), 
			        AfterSpawn = (Instance) => 
			        {
			           
			            var skin = ModAPI.LoadTexture("ODST.png");
						
			            

			            
			            var person = Instance.GetComponent<PersonBehaviour>();

			            
			            person.SetBodyTextures(skin, null, null, 1);

			            
			            person.SetBruiseColor(100, 100, 100); 
			            person.SetSecondBruiseColor(154, 0, 7); 
			            person.SetThirdBruiseColor(207, 206, 120); 
			            person.SetRottenColour(202, 199, 104); 
			            person.SetBloodColour(108, 0, 4); 
                        foreach (var body in person.Limbs)
                        {
                             body.BaseStrength *= 1f;                          
                             body.Health *= 2f;
                             body.BreakingThreshold *= 2f;
                        }


			        }
			    }
		    );
			 //ODST Chest armor
            ModAPI.Register(
                new Modification()
                {       
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "ODST Chestplates -buzz",
                    NameToOrderByOverride = "Human 2",
                    DescriptionOverride = "The simple set of armor plates used by ODSTs to cover their body.",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("ArmorIcon.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("ODSTop.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
                        armor.threepieces = true;

                        armor.stabResistance = 10f;
                        armor.armorPiece = "UpperBody";
                        armor.armorTier = 2;
                        armor.otherSprite = "ODSTmid.png";
                        armor.otherName = "ODST Chestplates -buzz";
                        armor.otherPiece = "MiddleBody";
                        armor.otherTier = 2;
                        armor.otherResist = 10f;
                        armor.thirdsprite = "ODSTbottom.png";
                        armor.thirdpart = "LowerBody";
                        armor.SpawnOtherParts();

                        Instance.FixColliders();
                    }
                }
            );
            //ODST Helmet
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "ODST Helmet -buzz",
                    NameToOrderByOverride = "ODST Chesplate -buzz 2",
                    DescriptionOverride = "The high-tech helmet used by ODSTs to prevent death from all sorts of causes, including heat and snipers!",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("HelmetIcon.png", 1f),
                    AfterSpawn = (Instance) =>
        
                    {
						Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("ODSTBackpack.png", 1f);
						Instance.FixColliders();
                    

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("ODSThelm.png", 1f);
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 10f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 2;
						
						Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.03f;
						Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.03f;
						Instance.FixColliders();
                    }
                }
            );
             //ODST Backpack
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "ODST Rucksack -buzz",
                    NameToOrderByOverride = "ODST Chestplates -buzz 2",
                    DescriptionOverride = "An armored rucksack given to ODSTs that carries communication equipment, rations, ammunition, etc. ",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("BackpackIcon.png", 1f),
                    AfterSpawn = (Instance) =>
                    {
						Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("ODSTBackpack.png", 1f);

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("ODSTbackpack.png", 1f);
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 1f;
                        armor.armorPiece = "UpperBody";
                        armor.armorTier = 1;
						
						Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.03f;
						Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.03f;
						Instance.FixColliders();
                    }
                }
            );
             //Marine (Halo Reach)
            ModAPI.Register(
			    new Modification()
			    {
			        OriginalItem = ModAPI.FindSpawnable("Human"), 
			        NameOverride = "Marine -buzz", 
			        DescriptionOverride = "Marines are the frontline infantry of the UNSC across planets and starships.",
			        CategoryOverride = ModAPI.FindCategory("Entities"), 
			        ThumbnailOverride = ModAPI.LoadSprite("MarineIcon.png"), 
			        AfterSpawn = (Instance) => 
			        {
			           
			            var skin = ModAPI.LoadTexture("Marine.png");
						
			            

			            
			            var person = Instance.GetComponent<PersonBehaviour>();

			            
			            person.SetBodyTextures(skin, null, null, 1);

			            
			            person.SetBruiseColor(100, 100, 100); 
			            person.SetSecondBruiseColor(154, 0, 7); 
			            person.SetThirdBruiseColor(207, 206, 120); 
			            person.SetRottenColour(202, 199, 104); 
			            person.SetBloodColour(108, 0, 4); 
			        }
			    }
			);
             //Marine Helmet
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Marine Helmet -buzz",
                    NameToOrderByOverride = "Marine Chestplate- buzz 2",
                    DescriptionOverride = "Standard issue marine helmet, nothing much to say here.",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("MarineHelmIcon1.png", 1f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("MarineHelm1.png", 1f);
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 10f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 1;
						
						Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.03f;
						Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.03f;
						Instance.FixColliders();
                    }
                }
            );
              //Marine Helmet (Balaclava)
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Marine Helmet (Balaclava) -buzz",
                    NameToOrderByOverride = "Marine Chestplate- buzz 2",
                    DescriptionOverride = "Standard issue marine helmet, but with a fancy scarf!",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("MarineHelmIcon2.png", 1f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("MarineHelm2.png", 1f);
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 10f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 1;
						
						Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.03f;
						Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.03f;
						Instance.FixColliders();
                    }
                }
            );
              //Marine Helmet (Goggles)
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Marine Helmet (Goggles) -buzz",
                    NameToOrderByOverride = "Marine Chestplate- buzz 2",
                    DescriptionOverride = "Standard issue marine helmet, but with 'shooting glasses', don't ask me why they have that name. ",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("MarineHelmIcon3.png", 1f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("MarineHelm3.png", 1f);
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 10f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 1;
						
						Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.03f;
						Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.03f;
						Instance.FixColliders();
                    }
                }
            );
            //Marine Chest Armor
            ModAPI.Register(
                new Modification()
                {       
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Marine Chestplates -buzz",
                    NameToOrderByOverride = "Marine -buzz 2",
                    DescriptionOverride = "Standard issue M52B Body Armor worn by Marines",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("MarineArmorIcon.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("MarineTop.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
                        armor.threepieces = true;

                        armor.stabResistance = 10f;
                        armor.armorPiece = "UpperBody";
                        armor.armorTier = 1;
                        armor.otherSprite = "MarineMid.png";
                        armor.otherName = "Marine Chestplates -buzz";
                        armor.otherPiece = "MiddleBody";
                        armor.otherTier = 1;
                        armor.otherResist = 10f;
                        armor.thirdsprite = "MarineBottom.png";
                        armor.thirdpart = "LowerBody";
                        armor.SpawnOtherParts();

                        Instance.FixColliders();
                    }
                }
            );
             //Marine Backpack
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Marine Rucksack -buzz",
                    NameToOrderByOverride = "Marine Chestplates -buzz 2",
                    DescriptionOverride = "Standard issue Marine rucksack. Carries things...",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("MarineBackpackIcon.png", 1f),
                    AfterSpawn = (Instance) =>
                    {
						Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("MarineBackpack.png", 1f);
						Instance.FixColliders();

                        
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("marinebackpack.png", 1f);
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 1f;
                        armor.armorPiece = "UpperBody";
                        armor.armorTier = 1;
						
						Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.03f;
						Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.03f;
                        Instance.FixColliders();
                    }
                }
            );    

            //Mjolnir Mk IV Helmet
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "MJOLNIR Mk IV Helmet -buzz",
                    NameToOrderByOverride = "Spartan -buzz 2",
                    DescriptionOverride = "The first Spartan helmet ever made! Does not include shields.",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("Spartanhelmicon1.png", 1f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("SpartanHelm1.png", 1f);
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 10f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 3;
						
						Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.03f;
						Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.03f;
						Instance.FixColliders();
                    }
                }
            );

            //Spartan (IV)
            ModAPI.Register(
			    new Modification()
			    {
			        OriginalItem = ModAPI.FindSpawnable("Human"), 
			        NameOverride = "Spartan (IV) -buzz", 
			        DescriptionOverride = "Spartans, the best, the elite, the faces of Halo. ",
			        CategoryOverride = ModAPI.FindCategory("Entities"), 
			        ThumbnailOverride = ModAPI.LoadSprite("Spartanicon1.png"), 
			        AfterSpawn = (Instance) => 
			        {
			           
			            var skin = ModAPI.LoadTexture("Spartan1.png");
						
			            

			            
			            var person = Instance.GetComponent<PersonBehaviour>();

			            
			            person.SetBodyTextures(skin, null, null, 1);

			            
			            person.SetBruiseColor(100, 100, 100); 
			            person.SetSecondBruiseColor(154, 0, 7); 
			            person.SetThirdBruiseColor(207, 206, 120); 
			            person.SetRottenColour(202, 199, 104); 
			            person.SetBloodColour(108, 0, 4); 
                         foreach (var body in person.Limbs)
                        {
                             body.BaseStrength *= 1.5f;                          
                             body.Health *= 5f;
                             body.BreakingThreshold *= 5f;
                        }
			        }
			    }
			);
            //Mjolnir Mk IV Shoulders
            ModAPI.Register(
                new Modification()
                {       
                    OriginalItem = ModAPI.FindSpawnable("Rod"), 
                    NameOverride = "MJOLNIR Mk IV Shoulderpads -buzz",
                    NameToOrderByOverride = "Spartan -buzz 2",
                    DescriptionOverride = "The large shoulder pauldrons of the Mark IV are unique to this model of MJOLNIR.", 
                    CategoryOverride = ModAPI.FindCategory("Entities"), 
                    ThumbnailOverride = ModAPI.LoadSprite("shoulderpadicon1.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("SpartanArmTop1.png"); 
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
                        armor.stabResistance = 5f;
                        armor.armorPiece = "UpperArm";
                        armor.armorTier = 3;
                        armor.otherSprite = "SpartanArmTop1.png";
                        armor.otherName = "MJOLNIR Mk IV Shoulderpads -buzz";
                        armor.otherPiece = "UpperArmFront";
                        armor.otherTier = 3;
                        armor.otherResist = 5f;
                        armor.SpawnOtherParts();
                        Instance.FixColliders();
                    }
                }
            );
            //Mjolnir Mk IV Thigh-pads
            ModAPI.Register(
                new Modification()
                {       
                    OriginalItem = ModAPI.FindSpawnable("Rod"), 
                    NameOverride = "MJOLNIR Mk IV Thighpads -buzz", 
                    NameToOrderByOverride = "Spartan -buzz 2",
                    DescriptionOverride = "A piece of the heavy plates of the Mk IV MJOLNIR armorset. Protects upper legs", 
                    CategoryOverride = ModAPI.FindCategory("Entities"), 
                    ThumbnailOverride = ModAPI.LoadSprite("thighpadicon1.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("SpartanLegTop1.png"); 
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
                        armor.stabResistance = 15f;
                        armor.armorPiece = "UpperLeg";
                        armor.armorTier = 3;
                        armor.otherSprite = "SpartanLegTop1.png";
                        armor.otherName = "MJOLNIR Mk IV Thighpads -buzz";
                        armor.otherPiece = "UpperLegFront";
                        armor.otherTier = 3;
                        armor.otherResist = 15f;
                        armor.SpawnOtherParts();
                        Instance.FixColliders();
                    }
                }
            );
            //Mjolnir Mk IV Gauntlets
            ModAPI.Register(
                new Modification()
                {       
                    OriginalItem = ModAPI.FindSpawnable("Rod"), 
                    NameOverride = "MJOLNIR Mk IV Gauntlets -buzz",
                    NameToOrderByOverride = "Spartan -buzz 2",
                    DescriptionOverride = "The armored gauntlets of the Mk IV Mjolnir armorset. Protects forearms and wrist.", 
                    CategoryOverride = ModAPI.FindCategory("Entities"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Gauntletsicon1.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("SpartanArmMid1.png"); 
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
                        armor.stabResistance = 5f;
                        armor.armorPiece = "LowerArm";
                        armor.armorTier = 3;
                        armor.otherSprite = "SpartanArmMid1.png";
                        armor.otherName = "MJOLNIR Mk IV Gauntlets -buzz";
                        armor.otherPiece = "LowerArmFront";
                        armor.otherTier = 3;
                        armor.otherResist = 5f;
                        armor.SpawnOtherParts();
                        Instance.FixColliders();
                    }
                }
            );
              //Mjolnir Mk IV Greaves
            ModAPI.Register(
                new Modification()
                {       
                    OriginalItem = ModAPI.FindSpawnable("Rod"), 
                    NameOverride = "MJOLNIR Mk IV Greaves -buzz",
                    NameToOrderByOverride = "Spartan -buzz 2",
                    DescriptionOverride = "The armored gauntlets of the Mk IV Mjolnir armorset. Protects forearms and wrist.", 
                    CategoryOverride = ModAPI.FindCategory("Entities"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Greavesicon1.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("SpartanLegMid1.png"); 
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
                        armor.stabResistance = 5f;
                        armor.armorPiece = "LowerLeg";
                        armor.armorTier = 3;
                        armor.otherSprite = "SpartanLegMid1.png";
                        armor.otherName = "MJOLNIR Mk IV Greaves -buzz";
                        armor.otherPiece = "LowerLegFront";
                        armor.otherTier = 3;
                        armor.otherResist = 5f;
                        armor.SpawnOtherParts();
                        Instance.FixColliders();
                    }
                }
            );
             //Mjolnir Mk IV Chest armor
            ModAPI.Register(
                new Modification()
                {       
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "MJOLNIR Mk IV Chestplates -buzz",
                    NameToOrderByOverride = "Spartan -buzz 2",
                    DescriptionOverride = "The heavy pieces of armor worn by Spartans with an integrated fusion reactor in the back, and with many revolutionary technologies ",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("SpartanArmorIcon1.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("SpartanTop1.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
                        armor.threepieces = true;

                        armor.stabResistance = 10f;
                        armor.armorPiece = "UpperBody";
                        armor.armorTier = 3;
                        armor.otherSprite = "SpartanMid1.png";
                        armor.otherName = "MJOLNIR Mk IV Chestplates -buzz";
                        armor.otherPiece = "MiddleBody";
                        armor.otherTier = 3;
                        armor.otherResist = 10f;
                        armor.thirdsprite = "SpartanBottom1.png";
                        armor.thirdpart = "LowerBody";
                        armor.SpawnOtherParts();

                        Instance.FixColliders();
                    }
                }
            );
             //Officer (Captain)
            ModAPI.Register(
			    new Modification()
			    {
			        OriginalItem = ModAPI.FindSpawnable("Human"), 
			        NameOverride = "Officer (Captain) -buzz", 
			        DescriptionOverride = "The standard enlisted UNSC Officer. Highly trained in commanding others ",
			        CategoryOverride = ModAPI.FindCategory("Entities"), 
			        ThumbnailOverride = ModAPI.LoadSprite("officericon.png"), 
			        AfterSpawn = (Instance) => 
			        {
			           
			            var skin = ModAPI.LoadTexture("officer1.png");
						
			            

			            
			            var person = Instance.GetComponent<PersonBehaviour>();

			            
			            person.SetBodyTextures(skin, null, null, 1);

			            
			            person.SetBruiseColor(100, 100, 100); 
			            person.SetSecondBruiseColor(154, 0, 7); 
			            person.SetThirdBruiseColor(207, 206, 120); 
			            person.SetRottenColour(202, 199, 104); 
			            person.SetBloodColour(108, 0, 4); 
                         foreach (var body in person.Limbs)
                        {
                             body.BaseStrength *= 1f;                          
                             body.Health *= 1.75f;
                             body.BreakingThreshold *= 1.75f;
                        }
			        }
			    }
			);
              //Officer Cap
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Officer Cap -buzz",
                    NameToOrderByOverride = "Officer (Captain) 2",
                    DescriptionOverride = "idk its a hat lol",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("officerhaticon.png", 1f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("cap1.png", 1f);
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 10f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 0;
						
						Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.03f;
						Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.03f;
						Instance.FixColliders();
                    }
                }
            );
             //DMR
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("M1 Garand"), 
                    NameOverride = "DMR -buzz", 
                    DescriptionOverride = "Headcase! Double kill! Killjoy! Triple kill! Revenge!",
                    CategoryOverride = ModAPI.FindCategory("Firearms"),
                    ThumbnailOverride = ModAPI.LoadSprite("DMRicon.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("DMR.png");                                                                                                         
                        //Colliders

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
                        }

                        var stock = Instance.AddComponent<BoxCollider2D>();
                        stock.offset = new Vector2(-0.5413804f, -0.01811719f);
                        stock.size = new Vector2(0.3813923f, 0.3544112f);

                        var main = Instance.AddComponent<BoxCollider2D>();
                        main.offset = new Vector2(0.04025123f, 0.02616942f);
                        main.size = new Vector2(0.7798809f, 0.2497338f);

                        var handle = Instance.AddComponent<BoxCollider2D>();
                        handle.offset = new Vector2(-0.3803752f, -0.1147423f);
                        handle.size = new Vector2(0.1318344f, 0.2175254f);

                        var barrel = Instance.AddComponent<BoxCollider2D>();
                        barrel.offset = new Vector2(0.6098071f, 0.06844282f);
                        barrel.size = new Vector2(0.3572426f, 0.1168741f);

                        var scope = Instance.AddComponent<BoxCollider2D>();
                        scope.offset = new Vector2(-0.1972316f, 0.2274717f);
                        scope.size = new Vector2(0.3129653f, 0.1450566f);


                        var firearm = Instance.GetComponent<FirearmBehaviour>();
                        firearm.ShotSounds = new AudioClip[]
            {
                ModAPI.LoadSound("DMR.mp3"),
            };
                    }
                }
            );
             //SMG
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Submachine Gun"), 
                    NameOverride = "SMG -buzz", 
                    DescriptionOverride = "The M7 SMG, everyone's favorite dual-wielding weapon. PATATATATATATATATAT.",
                    CategoryOverride = ModAPI.FindCategory("Firearms"),
                    ThumbnailOverride = ModAPI.LoadSprite("SMGicon.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("SMG1.png");                                                                                                         
                        //Colliders

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
                        }

                        var stock = Instance.AddComponent<BoxCollider2D>();
                        stock.offset = new Vector2(-0.4111044f, 0.0275389f);
                        stock.size = new Vector2(0.2444577f, 0.3161206f);

                        var main = Instance.AddComponent<BoxCollider2D>();
                        main.offset = new Vector2(0.05506536f, 0.1358587f);
                        main.size = new Vector2(0.6848804f, 0.1215122f);

                        var handle = Instance.AddComponent<BoxCollider2D>();
                        handle.offset = new Vector2(-0.04955876f, -0.0183593f);
                        handle.size = new Vector2(0.2260027f, 0.4299481f);

                        var barrel = Instance.AddComponent<BoxCollider2D>();
                        barrel.offset = new Vector2(0.4662198f, 0.1358587f);
                        barrel.size = new Vector2(0.1342271f, 0.09213734f);

                        var grip = Instance.AddComponent<BoxCollider2D>();
                        grip.offset = new Vector2(0.3560891f, -0.018359f);
                        grip.size = new Vector2(0.1489112f, 0.4299481f);


                        var firearm = Instance.GetComponent<FirearmBehaviour>();
                        firearm.ShotSounds = new AudioClip[]
            {
                ModAPI.LoadSound("SMG.wav"),
            };

                        


                    }
                }
            );
             //Shotgun
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Shotgun"), 
                    NameOverride = "Shotgun -buzz", 
                    DescriptionOverride = "shoot it. shoot it now. feel the satisfaction. feel the power.",
                    CategoryOverride = ModAPI.FindCategory("Firearms"),
                    ThumbnailOverride = ModAPI.LoadSprite("shotgunicon.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("shotgun.png");                                                                                                         
                        //Colliders

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
                        }

                        var stock = Instance.AddComponent<BoxCollider2D>();
                        stock.offset = new Vector2(-0.6043812f, 0.08846605f);
                        stock.size = new Vector2(0.5912375f, 0.3161206f);

                        var main = Instance.AddComponent<BoxCollider2D>();
                        main.offset = new Vector2(0.2026889f, 0.0995245f);
                        main.size = new Vector2(1.026097f, 0.2464526f);

                        var handle = Instance.AddComponent<BoxCollider2D>();
                        handle.offset = new Vector2(-0.4164334f, -0.165874f);
                        handle.size = new Vector2(0.3627518f, 0.2759416f);

                        var barrel = Instance.AddComponent<BoxCollider2D>();
                        barrel.offset = new Vector2(0.807070f, 0.1105826f);
                        barrel.size = new Vector2(0.1858597f, 0.2243359f);

                        var grip = Instance.AddComponent<BoxCollider2D>();
                        grip.offset = new Vector2(0.2616529f, -0.08109391f);
                        grip.size = new Vector2(0.583867f, 0.1211257f);


                        var firearm = Instance.GetComponent<FirearmBehaviour>();
                        firearm.ShotSounds = new AudioClip[]
            {
                ModAPI.LoadSound("shotgun.wav"),
            };

                        


                    }
                }
            );
            //Marine Pilot
            ModAPI.Register(
			    new Modification()
			    {
			        OriginalItem = ModAPI.FindSpawnable("Human"), 
			        NameOverride = "Marine Pilot -buzz", 
			        DescriptionOverride = "Marine Pilots fly Hornets, Pelicans, and other UNSC air vehicles.",
			        CategoryOverride = ModAPI.FindCategory("Entities"), 
			        ThumbnailOverride = ModAPI.LoadSprite("marinepiloticon.png"), 
			        AfterSpawn = (Instance) => 
			        {
			           
			            var skin = ModAPI.LoadTexture("Marinepilot.png");
						
			            

			            
			            var person = Instance.GetComponent<PersonBehaviour>();

			            
			            person.SetBodyTextures(skin, null, null, 1);

			            
			            person.SetBruiseColor(100, 100, 100); 
			            person.SetSecondBruiseColor(154, 0, 7); 
			            person.SetThirdBruiseColor(207, 206, 120); 
			            person.SetRottenColour(202, 199, 104); 
			            person.SetBloodColour(108, 0, 4); 
			        }
			    }
			);
             //Marine Pilot Helmet
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Marine Pilot Helmet -buzz",
                    NameToOrderByOverride = "Marine Pilot- buzz 2",
                    DescriptionOverride = "Fitted with HUD and situation awareness things. Modified marine helmet..",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("marinepilothelmicon.png", 1f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Marinepilothelm.png", 1f);
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 10f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 1;
						
						Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.03f;
						Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.03f;
						Instance.FixColliders();
                    }
                }
            );
            //Marine Pilot Chest Armor
            ModAPI.Register(
                new Modification()
                {       
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Marine Pilot Chestplates -buzz",
                    NameToOrderByOverride = "Marine Pilot -buzz 2",
                    DescriptionOverride = "plot armor? heh heh?",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("marinepilotarmoricon.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Marinepilotop.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
                        armor.threepieces = true;

                        armor.stabResistance = 10f;
                        armor.armorPiece = "UpperBody";
                        armor.armorTier = 1;
                        armor.otherSprite = "MarinepilotMid.png";
                        armor.otherName = "Marine Chestplates -buzz";
                        armor.otherPiece = "MiddleBody";
                        armor.otherTier = 1;
                        armor.otherResist = 10f;
                        armor.thirdsprite = "MarinepilotBottom.png";
                        armor.thirdpart = "LowerBody";
                        armor.SpawnOtherParts();

                        Instance.FixColliders();
                    }
                }
            );
            //Marine MeDICK
            ModAPI.Register(
			    new Modification()
			    {
			        OriginalItem = ModAPI.FindSpawnable("Human"), 
			        NameOverride = "Marine Medic -buzz", 
			        DescriptionOverride = "Skilled in treating battle wounds and carrying wounded to safety.",
			        CategoryOverride = ModAPI.FindCategory("Entities"), 
			        ThumbnailOverride = ModAPI.LoadSprite("medicicon.png"), 
			        AfterSpawn = (Instance) => 
			        {
			           
			            var skin = ModAPI.LoadTexture("Marinemedic.png");
						
			            

			            
			            var person = Instance.GetComponent<PersonBehaviour>();

			            
			            person.SetBodyTextures(skin, null, null, 1);

			            
			            person.SetBruiseColor(100, 100, 100); 
			            person.SetSecondBruiseColor(154, 0, 7); 
			            person.SetThirdBruiseColor(207, 206, 120); 
			            person.SetRottenColour(202, 199, 104); 
			            person.SetBloodColour(108, 0, 4); 
			        }
			    }
			);
             //Marine MeDICK Helmet
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Marine Medic Helmet -buzz",
                    NameToOrderByOverride = "Marine Medic- buzz 2",
                    DescriptionOverride = "The helmet that indicates a Marine Medic, along with their backpack and shoulderpad.",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("medichelmicon.png", 1f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Marinemedichelm.png", 1f);
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 10f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 1;
						
						Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.03f;
						Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.03f;
						Instance.FixColliders();
                    }
                }
            );
             //Marine MeDICK Backpack
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Marine Medic Rucksack -buzz",
                    NameToOrderByOverride = "Marine Medic -buzz 2",
                    DescriptionOverride = "DRUG BAG",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("medicbackpackIcon.png", 1f),
                    AfterSpawn = (Instance) =>
                    {
						Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("MarinemedicBackpack.png", 1f);
						Instance.FixColliders();

                        
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("marinemedicbackpack.png", 1f);
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 1f;
                        armor.armorPiece = "UpperBody";
                        armor.armorTier = 1;
						
						Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.03f;
						Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.03f;
                        Instance.FixColliders();
                    }
                }
            );
              //Marine Medic Chest Armor
            ModAPI.Register(
                new Modification()
                {       
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Marine Medic Chestplates -buzz",
                    NameToOrderByOverride = "Marine Medic -buzz 2",
                    DescriptionOverride = "Contains extra bags with medical equipment",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("medichestIcon.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("MarineMedicTop.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
                        armor.threepieces = true;

                        armor.stabResistance = 10f;
                        armor.armorPiece = "UpperBody";
                        armor.armorTier = 1;
                        armor.otherSprite = "MarineMedicMid.png";
                        armor.otherName = "Marine Chestplates -buzz";
                        armor.otherPiece = "MiddleBody";
                        armor.otherTier = 1;
                        armor.otherResist = 10f;
                        armor.thirdsprite = "MarineMedicBottom.png";
                        armor.thirdpart = "LowerBody";
                        armor.SpawnOtherParts();

                        Instance.FixColliders();
                    }
                }
            );

             //Mjolnir Mk VI Shoulders
            ModAPI.Register(
                new Modification()
                {       
                    OriginalItem = ModAPI.FindSpawnable("Rod"), 
                    NameOverride = "MJOLNIR Mk VI Shoulderpads -buzz",
                    NameToOrderByOverride = "Spartan (VI) -buzz 2",
                    DescriptionOverride = "Small profile, great protection.", 
                    CategoryOverride = ModAPI.FindCategory("Entities"), 
                    ThumbnailOverride = ModAPI.LoadSprite("shoulderpadicon2.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("SpartanArmTop2.png"); 
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
                        armor.stabResistance = 5f;
                        armor.armorPiece = "UpperArm";
                        armor.armorTier = 3;
                        armor.otherSprite = "SpartanArmTop2.png";
                        armor.otherName = "MJOLNIR Mk VI Shoulderpads -buzz";
                        armor.otherPiece = "UpperArmFront";
                        armor.otherTier = 3;
                        armor.otherResist = 5f;
                        armor.SpawnOtherParts();
                        Instance.FixColliders();
                    }
                }
            );
             //Mjolnir Mk VI Chest armor
            ModAPI.Register(
                new Modification()
                {       
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "MJOLNIR Mk VI Chestplates -buzz",
                    NameToOrderByOverride = "Spartan (VI) -buzz 2",
                    DescriptionOverride = "The third iteration of the MJOLNIR powersuit contains armor pieces that can only be removed with special tools.",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("SpartanArmorIcon2.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("SpartanTop2.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
                        armor.threepieces = true;

                        armor.stabResistance = 10f;
                        armor.armorPiece = "UpperBody";
                        armor.armorTier = 3;
                        armor.otherSprite = "SpartanMid2.png";
                        armor.otherName = "MJOLNIR Mk VI Chestplates -buzz";
                        armor.otherPiece = "MiddleBody";
                        armor.otherTier = 3;
                        armor.otherResist = 10f;
                        armor.thirdsprite = "SpartanBottom2.png";
                        armor.thirdpart = "LowerBody";
                        armor.SpawnOtherParts();

                        Instance.FixColliders();
                    }
                }
            );
            //Mjolnir Mk VI Gauntlets
            ModAPI.Register(
                new Modification()
                {       
                    OriginalItem = ModAPI.FindSpawnable("Rod"), 
                    NameOverride = "MJOLNIR Mk VI Gauntlets -buzz",
                    NameToOrderByOverride = "Spartan (VI) -buzz 2",
                    DescriptionOverride = "The armored gauntlets of the Mk VI Mjolnir armorset. Protects forearms and wrist.", 
                    CategoryOverride = ModAPI.FindCategory("Entities"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Gauntletsicon2.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("SpartanArmMid2.png"); 
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
                        armor.stabResistance = 5f;
                        armor.armorPiece = "LowerArm";
                        armor.armorTier = 3;
                        armor.otherSprite = "SpartanArmMid2.png";
                        armor.otherName = "MJOLNIR Mk VI Gauntlets -buzz";
                        armor.otherPiece = "LowerArmFront";
                        armor.otherTier = 3;
                        armor.otherResist = 5f;
                        armor.SpawnOtherParts();
                        Instance.FixColliders();
                    }
                }
            );
             //Mjolnir Mk VI Thigh-pads
            ModAPI.Register(
                new Modification()
                {       
                    OriginalItem = ModAPI.FindSpawnable("Rod"), 
                    NameOverride = "MJOLNIR Mk VI Thighpads -buzz", 
                    NameToOrderByOverride = "Spartan (VI) -buzz 2",
                    DescriptionOverride = "A piece of the heavy plates of the Mk VI MJOLNIR armorset. Protects upper legs", 
                    CategoryOverride = ModAPI.FindCategory("Entities"), 
                    ThumbnailOverride = ModAPI.LoadSprite("thighpadicon2.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("SpartanLegTop2.png"); 
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
                        armor.stabResistance = 15f;
                        armor.armorPiece = "UpperLeg";
                        armor.armorTier = 3;
                        armor.otherSprite = "SpartanLegTop2.png";
                        armor.otherName = "MJOLNIR Mk VI Thighpads -buzz";
                        armor.otherPiece = "UpperLegFront";
                        armor.otherTier = 3;
                        armor.otherResist = 15f;
                        armor.SpawnOtherParts();
                        Instance.FixColliders();
                    }
                }
            );
            //Mjolnir Mk VI Greaves
            ModAPI.Register(
                new Modification()
                {       
                    OriginalItem = ModAPI.FindSpawnable("Rod"), 
                    NameOverride = "MJOLNIR Mk VI Greaves -buzz",
                    NameToOrderByOverride = "Spartan (VI) -buzz 2",
                    DescriptionOverride = "The armored gauntlets of the Mk VI Mjolnir armorset. Protects forearms and wrist.", 
                    CategoryOverride = ModAPI.FindCategory("Entities"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Greavesicon2.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("SpartanLegMid2.png"); 
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
                        armor.stabResistance = 5f;
                        armor.armorPiece = "LowerLeg";
                        armor.armorTier = 3;
                        armor.otherSprite = "SpartanLegMid2.png";
                        armor.otherName = "MJOLNIR Mk VI Greaves -buzz";
                        armor.otherPiece = "LowerLegFront";
                        armor.otherTier = 3;
                        armor.otherResist = 5f;
                        armor.SpawnOtherParts();
                        Instance.FixColliders();
                    }
                }
            );
             //Mjolnir Mk VI Helmet
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "MJOLNIR Mk VI Helmet -buzz",
                    NameToOrderByOverride = "Spartan (VI) -buzz 2",
                    DescriptionOverride = "The most famous helmet in the entire Halo Galaxy.",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("Spartanhelmicon2.png", 1f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("SpartanHelm2.png", 1f);
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 10f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 3;
						
						Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.03f;
						Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.03f;
						Instance.FixColliders();
                    }
                }
            );
              //Spartan (VI)
            ModAPI.Register(
			    new Modification()
			    {
			        OriginalItem = ModAPI.FindSpawnable("Human"), 
			        NameOverride = "Spartan (VI) -buzz", 
			        DescriptionOverride = "This spartan can equip the Mk VI MJOLNIR Armor",
			        CategoryOverride = ModAPI.FindCategory("Entities"), 
			        ThumbnailOverride = ModAPI.LoadSprite("Spartanicon2.png"), 
			        AfterSpawn = (Instance) => 
			        {
			           
			            var skin = ModAPI.LoadTexture("Spartan2.png");
						
			            

			            
			            var person = Instance.GetComponent<PersonBehaviour>();

			            
			            person.SetBodyTextures(skin, null, null, 1);

			            
			            person.SetBruiseColor(100, 100, 100); 
			            person.SetSecondBruiseColor(154, 0, 7); 
			            person.SetThirdBruiseColor(207, 206, 120); 
			            person.SetRottenColour(202, 199, 104); 
			            person.SetBloodColour(108, 0, 4); 
                         foreach (var body in person.Limbs)
                        {
                             body.BaseStrength *= 1.5f;                          
                             body.Health *= 5f;
                             body.BreakingThreshold *= 5f;
                        }
			        }
			    }
			);
             //Plasma Grenade
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Sticky Grenade"),
                    NameOverride = "Plasma Grenade -buzz",
                    NameToOrderByOverride = "Sticky Grenade",
                    DescriptionOverride = "GET IT OFF! SOMEONE GET IT OFF! PLEASE PELASE PLEASE GET IT OFF GET IT OFF! ",
                    CategoryOverride = ModAPI.FindCategory("Explosives"),
                    ThumbnailOverride = ModAPI.LoadSprite("plasmagrenadeicon.png", 1f),
                    AfterSpawn = (Instance) =>
                    {
						Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("plasmagrenade.png", 1f);
						Instance.FixColliders();
                    }
                }
            );
            //Kat
            ModAPI.Register(
			    new Modification()
			    {
			        OriginalItem = ModAPI.FindSpawnable("Human"), 
			        NameOverride = "Kat B320 -buzz", 
			        DescriptionOverride = "Intelligence Specialist of NOBLE Team, vulnerable to flying crystals.",
			        CategoryOverride = ModAPI.FindCategory("Entities"), 
			        ThumbnailOverride = ModAPI.LoadSprite("Spartanicon2.png"), 
			        AfterSpawn = (Instance) => 
			        {
			           
			            var skin = ModAPI.LoadTexture("kat.png");
						
			            

			            
			            var person = Instance.GetComponent<PersonBehaviour>();

			            
			            person.SetBodyTextures(skin, null, null, 1);

			            
			            person.SetBruiseColor(100, 100, 100); 
			            person.SetSecondBruiseColor(154, 0, 7); 
			            person.SetThirdBruiseColor(207, 206, 120); 
			            person.SetRottenColour(202, 199, 104); 
			            person.SetBloodColour(108, 0, 4); 
                         foreach (var body in person.Limbs)
                        {
                             body.BaseStrength *= 1.5f;                          
                             body.Health *= 5f;
                             body.BreakingThreshold *= 5f;
                        }
			        }
			    }
			);
             //Kat's Helmet
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Kat's Helmet -buzz",
                    NameToOrderByOverride = "Kat B320 -buzz 2",
                    DescriptionOverride = "The air-assault helmet that Kat wears, it's gone through too much lol",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("Spartanhelmicon2.png", 1f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("kathelm.png", 1f);
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 10f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 3;
						
						Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.03f;
						Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.03f;
						Instance.FixColliders();
                    }
                }
            );
             //Kat's Chest armor
            ModAPI.Register(
                new Modification()
                {       
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Kat's Chestplates -buzz",
                    NameToOrderByOverride = "Kat  B320 -buzz 2",
                    DescriptionOverride = "Cyan Mark V Chest armor",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("SpartanArmorIcon2.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("katop.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
                        armor.threepieces = true;

                        armor.stabResistance = 10f;
                        armor.armorPiece = "UpperBody";
                        armor.armorTier = 3;
                        armor.otherSprite = "katmid.png";
                        armor.otherName = "Kat's Chestplates -buzz";
                        armor.otherPiece = "MiddleBody";
                        armor.otherTier = 3;
                        armor.otherResist = 10f;
                        armor.thirdsprite = "katbottom.png";
                        armor.thirdpart = "LowerBody";
                        armor.SpawnOtherParts();

                        Instance.FixColliders();
                    }
                }
            );
             //Kat's Shoulders
            ModAPI.Register(
                new Modification()
                {       
                    OriginalItem = ModAPI.FindSpawnable("Rod"), 
                    NameOverride = "Kat's Shoulderpads -buzz",
                    NameToOrderByOverride = "Kat B320 -buzz 2",
                    DescriptionOverride = "Kat uses the FJ/PARA shoulderpads on the Mark V platform to protect her.", 
                    CategoryOverride = ModAPI.FindCategory("Entities"), 
                    ThumbnailOverride = ModAPI.LoadSprite("shoulderpadicon2.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("katarmtop.png"); 
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
                        armor.stabResistance = 5f;
                        armor.armorPiece = "UpperArm";
                        armor.armorTier = 3;
                        armor.otherSprite = "katarmtop.png";
                        armor.otherName = "Kat's Shoulderpads -buzz";
                        armor.otherPiece = "UpperArmFront";
                        armor.otherTier = 3;
                        armor.otherResist = 5f;
                        armor.SpawnOtherParts();
                        Instance.FixColliders();
                    }
                }
            );
             //Kat's Gauntlets
            ModAPI.Register(
                new Modification()
                {       
                    OriginalItem = ModAPI.FindSpawnable("Rod"), 
                    NameOverride = "Kat's Gauntlets -buzz",
                    NameToOrderByOverride = "Kat B320 -buzz 2",
                    DescriptionOverride = "The armored gauntlets of Kat's armorset. Protects forearms and wrist.", 
                    CategoryOverride = ModAPI.FindCategory("Entities"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Gauntletsicon2.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("katarmid.png"); 
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
                        armor.stabResistance = 5f;
                        armor.armorPiece = "LowerArm";
                        armor.armorTier = 3;
                        armor.otherSprite = "katarmid.png";
                        armor.otherName = "Kat's Gauntlets -buzz";
                        armor.otherPiece = "LowerArmFront";
                        armor.otherTier = 3;
                        armor.otherResist = 5f;
                        armor.SpawnOtherParts();
                        Instance.FixColliders();
                    }
                }
            );
             //Kat's Thigh-pads
            ModAPI.Register(
                new Modification()
                {       
                    OriginalItem = ModAPI.FindSpawnable("Rod"), 
                    NameOverride = "Kat's Thighpads -buzz", 
                    NameToOrderByOverride = "Kat B320 -buzz 2",
                    DescriptionOverride = "A piece of the heavy plates of the Kat's armorset. Protects upper legs", 
                    CategoryOverride = ModAPI.FindCategory("Entities"), 
                    ThumbnailOverride = ModAPI.LoadSprite("thighpadicon2.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("katlegtop.png"); 
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
                        armor.stabResistance = 15f;
                        armor.armorPiece = "UpperLeg";
                        armor.armorTier = 3;
                        armor.otherSprite = "katlegtop.png";
                        armor.otherName = "Kat's Thighpads -buzz";
                        armor.otherPiece = "UpperLegFront";
                        armor.otherTier = 3;
                        armor.otherResist = 15f;
                        armor.SpawnOtherParts();
                        Instance.FixColliders();
                    }
                }
            );
             //Kat's Greaves
            ModAPI.Register(
                new Modification()
                {       
                    OriginalItem = ModAPI.FindSpawnable("Rod"), 
                    NameOverride = "Kat's Greaves -buzz",
                    NameToOrderByOverride = "Kat B320 -buzz 2",
                    DescriptionOverride = "The armored greaves of the Kat's armorset. Protects forearms and wrist.", 
                    CategoryOverride = ModAPI.FindCategory("Entities"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Greavesicon2.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("katlegmid.png"); 
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
                        armor.stabResistance = 5f;
                        armor.armorPiece = "LowerLeg";
                        armor.armorTier = 3;
                        armor.otherSprite = "katlegmid.png";
                        armor.otherName = "Kat's Greaves -buzz";
                        armor.otherPiece = "LowerLegFront";
                        armor.otherTier = 3;
                        armor.otherResist = 5f;
                        armor.SpawnOtherParts();
                        Instance.FixColliders();
                    }
                }
            );
             //Noble Six
            ModAPI.Register(
			    new Modification()
			    {
			        OriginalItem = ModAPI.FindSpawnable("Human"), 
			        NameOverride = "SPARTAN B312- -buzz", 
			        DescriptionOverride = "The only other spartan to recieve the hyper-lethal status by Dr. Halsey, also known as Noble Six",
			        CategoryOverride = ModAPI.FindCategory("Entities"), 
			        ThumbnailOverride = ModAPI.LoadSprite("Spartanicon2.png"), 
			        AfterSpawn = (Instance) => 
			        {
			           
			            var skin = ModAPI.LoadTexture("six.png");
						
			            

			            
			            var person = Instance.GetComponent<PersonBehaviour>();

			            
			            person.SetBodyTextures(skin, null, null, 1);

			            
			            person.SetBruiseColor(100, 100, 100); 
			            person.SetSecondBruiseColor(154, 0, 7); 
			            person.SetThirdBruiseColor(207, 206, 120); 
			            person.SetRottenColour(202, 199, 104); 
			            person.SetBloodColour(108, 0, 4); 
                         foreach (var body in person.Limbs)
                        {
                             body.BaseStrength *= 1.5f;                          
                             body.Health *= 5f;
                             body.BreakingThreshold *= 5f;
                        }
			        }
			    }
			);
             //Six's Helmet
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "B312's Helmet -buzz",
                    NameToOrderByOverride = "SPARTAN B312 -buzz 2",
                    DescriptionOverride = "The Mark V(B) helmet is the standard helmet for spartans who wear the Mark V(B) platform that was the first to use shields!",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("Spartanhelmicon2.png", 1f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sixhelm.png", 1f);
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 10f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 3;
						
						Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.03f;
						Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.03f;
						Instance.FixColliders();
                    }
                }
            );
              //Six's Shoulders
            ModAPI.Register(
                new Modification()
                {       
                    OriginalItem = ModAPI.FindSpawnable("Rod"), 
                    NameOverride = "B312's Shoulderpads -buzz",
                    NameToOrderByOverride = "SPARTAN B312 -buzz 2",
                    DescriptionOverride = "Six uses the standard shoulder protection on the Mark V platform to protect him.", 
                    CategoryOverride = ModAPI.FindCategory("Entities"), 
                    ThumbnailOverride = ModAPI.LoadSprite("shoulderpadicon2.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sixarmtop.png"); 
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
                        armor.stabResistance = 5f;
                        armor.armorPiece = "UpperArm";
                        armor.armorTier = 3;
                        armor.otherSprite = "sixarmtop.png";
                        armor.otherName = "B312's Shoulderpads -buzz";
                        armor.otherPiece = "UpperArmFront";
                        armor.otherTier = 3;
                        armor.otherResist = 5f;
                        armor.SpawnOtherParts();
                        Instance.FixColliders();
                    }
                }
            );
             //Six's Gauntlets
            ModAPI.Register(
                new Modification()
                {       
                    OriginalItem = ModAPI.FindSpawnable("Rod"), 
                    NameOverride = "B312's Gauntlets -buzz",
                    NameToOrderByOverride = "Kat B320 -buzz 2",
                    DescriptionOverride = "yknow i should really just put six's gauntlets but this is for ease of use", 
                    CategoryOverride = ModAPI.FindCategory("Entities"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Gauntletsicon2.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sixarmid.png"); 
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
                        armor.stabResistance = 5f;
                        armor.armorPiece = "LowerArm";
                        armor.armorTier = 3;
                        armor.otherSprite = "sixarmid.png";
                        armor.otherName = "B312's Gauntlets -buzz";
                        armor.otherPiece = "LowerArmFront";
                        armor.otherTier = 3;
                        armor.otherResist = 5f;
                        armor.SpawnOtherParts();
                        Instance.FixColliders();
                    }
                }
            );
             //B312's Chest armor
            ModAPI.Register(
                new Modification()
                {       
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "B312's Chestplates -buzz",
                    NameToOrderByOverride = "SPARTAN B312 -buzz 2",
                    DescriptionOverride = "lmao he got stabbed in the chest armor what a loser",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("SpartanArmorIcon2.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sixtop.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
                        armor.threepieces = true;

                        armor.stabResistance = 10f;
                        armor.armorPiece = "UpperBody";
                        armor.armorTier = 3;
                        armor.otherSprite = "sixmid.png";
                        armor.otherName = "B312's Chestplates -buzz";
                        armor.otherPiece = "MiddleBody";
                        armor.otherTier = 3;
                        armor.otherResist = 10f;
                        armor.thirdsprite = "sixbottom.png";
                        armor.thirdpart = "LowerBody";
                        armor.SpawnOtherParts();

                        Instance.FixColliders();
                    }
                }
            );
             //B312's Thigh-pads
            ModAPI.Register(
                new Modification()
                {       
                    OriginalItem = ModAPI.FindSpawnable("Rod"), 
                    NameOverride = "B312's Thighpads -buzz", 
                    NameToOrderByOverride = "SPARTAN B312 -buzz 2",
                    DescriptionOverride = "A piece of the heavy plates of Six's armorset. Protects upper legs", 
                    CategoryOverride = ModAPI.FindCategory("Entities"), 
                    ThumbnailOverride = ModAPI.LoadSprite("thighpadicon2.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sixlegtop.png"); 
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
                        armor.stabResistance = 15f;
                        armor.armorPiece = "UpperLeg";
                        armor.armorTier = 3;
                        armor.otherSprite = "sixlegtop.png";
                        armor.otherName = "B312's Thighpads -buzz";
                        armor.otherPiece = "UpperLegFront";
                        armor.otherTier = 3;
                        armor.otherResist = 15f;
                        armor.SpawnOtherParts();
                        Instance.FixColliders();
                    }
                }
            );
            //Six's Greaves
            ModAPI.Register(
                new Modification()
                {       
                    OriginalItem = ModAPI.FindSpawnable("Rod"), 
                    NameOverride = "B312's Greaves -buzz",
                    NameToOrderByOverride = "SPARTAN B312 -buzz 2",
                    DescriptionOverride = "The armored gauntlets of Six's armorset. Protects forearms and wrist.", 
                    CategoryOverride = ModAPI.FindCategory("Entities"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Greavesicon2.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sixlegmid.png"); 
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
                        armor.stabResistance = 5f;
                        armor.armorPiece = "LowerLeg";
                        armor.armorTier = 3;
                        armor.otherSprite = "sixlegmid.png";
                        armor.otherName = "B312's Greaves -buzz";
                        armor.otherPiece = "LowerLegFront";
                        armor.otherTier = 3;
                        armor.otherResist = 5f;
                        armor.SpawnOtherParts();
                        Instance.FixColliders();
                    }
                }
            );
              //Nuke
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Dynamite"),
                    NameOverride = "HAVOK Tactical Nuclear Weapon -buzz",
                    DescriptionOverride = "DO. NOT. DROP. FOR THE LOVE OF GOD.",
                    CategoryOverride = ModAPI.FindCategory("Explosives"),
                    ThumbnailOverride = ModAPI.LoadSprite("officerhaticon.png", 1f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("nuclearfootball.png", 1f);
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 0.24f;
                        Instance.GetComponent<ExplosiveBehaviour>().FragmentForce = 10f;
                        Instance.GetComponent<ExplosiveBehaviour>().ShockwaveStrength = 10f;
                        Instance.GetComponent<ExplosiveBehaviour>().Range = 100f;
                        Instance.GetComponent<ExplosiveBehaviour>().FragmentationRayCount = 250;
                        Instance.FixColliders();
                    }
                }
            );
              //Fusion Coil
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Red Barrel"),
                    NameOverride = "Fusion Coil -buzz",
                    DescriptionOverride = "The safest, most intelligent way to transport and store highly explosive compressed plasma energy." ,
                    CategoryOverride = ModAPI.FindCategory("Explosives"),
                    ThumbnailOverride = ModAPI.LoadSprite("officerhaticon.png", 1f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("fusioncoil.png", 1f);
                    }
                }
            );
        }         
    } 
}     